/*
 *  Copyright (C) 2005, 2006, 2007, 2008, 2009, 2010 Apple Inc. All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 *
 */

// RefPtr and PassRefPtr are documented at http://webkit.org/coding/RefPtr.html

#pragma once

#include <algorithm>
#include <utility>
#include <wtf/FastAllocBase.h>
#include <wtf/GetPtr.h>
#include <wtf/PassRefPtr.h>

namespace WTF {

template<typename T> class PassRefPtr;

template<typename T> class RefPtr {
	WTF_MAKE_FAST_ALLOCATED;
public:
	typedef T ValueType;
	typedef ValueType* PtrType;

	ALWAYS_INLINE RefPtr() : m_ptr(nullptr) { }
	ALWAYS_INLINE RefPtr(std::nullptr_t) : m_ptr(nullptr) { }
	ALWAYS_INLINE RefPtr(T* ptr) : m_ptr(ptr) { refIfNotNull(ptr); }
	ALWAYS_INLINE RefPtr(T& object) : m_ptr(&object) { object.ref(); }
	ALWAYS_INLINE RefPtr(const RefPtr& o) : m_ptr(o.m_ptr) { refIfNotNull(m_ptr); }
	template<typename U> ALWAYS_INLINE RefPtr(const RefPtr<U>& o) : m_ptr(o.get()) { refIfNotNull(m_ptr); }

	ALWAYS_INLINE RefPtr(RefPtr&& o) : m_ptr(o.leakRef()) { }
	template<typename U> RefPtr(RefPtr<U>&& o) : m_ptr(o.leakRef()) { }

	// See comments in PassRefPtr.h for an explanation of why this takes a const reference.
	template<typename U> ALWAYS_INLINE RefPtr(const PassRefPtr<U>&);

	template<typename U> RefPtr(Ref<U>&&);

	// Hash table deleted values, which are only constructed and never copied or destroyed.
	ALWAYS_INLINE RefPtr(HashTableDeletedValueType) : m_ptr(hashTableDeletedValue()) { }
	ALWAYS_INLINE bool isHashTableDeletedValue() const { return m_ptr == hashTableDeletedValue(); }

	ALWAYS_INLINE ~RefPtr() { clear(); }

	ALWAYS_INLINE T* get() const { return m_ptr; }

	RefPtr copyRef() const WARN_UNUSED_RETURN
	{
		return RefPtr(m_ptr);
	}

	ALWAYS_INLINE T* leakRef() WARN_UNUSED_RETURN;

	ALWAYS_INLINE void clear();
	ALWAYS_INLINE PassRefPtr<T> release() { PassRefPtr<T> tmp = adoptRef(m_ptr); m_ptr = nullptr; return tmp; }
	ALWAYS_INLINE Ref<T> releaseNonNull() { Ref<T> tmp = adoptRef(*m_ptr); m_ptr = nullptr; return tmp; }

	ALWAYS_INLINE T& operator*() const { return *m_ptr; }
	ALWAYS_INLINE T* operator->() const { return m_ptr; }

	ALWAYS_INLINE bool operator!() const { return !m_ptr; }

	ALWAYS_INLINE explicit operator bool() const { return !!m_ptr; }

	ALWAYS_INLINE RefPtr& operator=(const RefPtr&);
	ALWAYS_INLINE RefPtr& operator=(T&);
	ALWAYS_INLINE RefPtr& operator=(T*);
	ALWAYS_INLINE RefPtr& operator=(const PassRefPtr<T>&);
#if !COMPILER_SUPPORTS(CXX_NULLPTR)
	ALWAYS_INLINE RefPtr& operator=(std::nullptr_t) { clear(); return *this; }
#endif
	template<typename U> ALWAYS_INLINE RefPtr& operator=(const RefPtr<U>&);
	template<typename U> ALWAYS_INLINE RefPtr& operator=(const PassRefPtr<U>&);
	RefPtr& operator=(RefPtr&&);
	template<typename U> RefPtr& operator=(RefPtr<U>&&);
	template<typename U> RefPtr& operator=(Ref<U>&&);

	ALWAYS_INLINE void swap(RefPtr&);

	ALWAYS_INLINE static T* hashTableDeletedValue() { return reinterpret_cast<T*>(-1); }

private:
	T* m_ptr;
};

template<typename T> template<typename U> inline RefPtr<T>::RefPtr(Ref<U>&& reference)
	: m_ptr(&reference.leakRef())
{
}

template<typename T> template<typename U> ALWAYS_INLINE RefPtr<T>::RefPtr(const PassRefPtr<U>& o)
	: m_ptr(o.leakRef())
{
}

template<typename T> ALWAYS_INLINE T* RefPtr<T>::leakRef()
{
	T* ptr = m_ptr;
	m_ptr = nullptr;
	return ptr;
}

template<typename T> ALWAYS_INLINE void RefPtr<T>::clear()
{
	T* ptr = m_ptr;
	m_ptr = nullptr;
	derefIfNotNull(ptr);
}

template<typename T> ALWAYS_INLINE RefPtr<T>& RefPtr<T>::operator=(const RefPtr<T>& o)
{
	T* optr = o.get();
	refIfNotNull(optr);
	T* ptr = m_ptr;
	m_ptr = optr;
	derefIfNotNull(ptr);
	return *this;
}

template<typename T> template<typename U> ALWAYS_INLINE RefPtr<T>& RefPtr<T>::operator=(const RefPtr<U>& o)
{
	T* optr = o.get();
	refIfNotNull(optr);
	T* ptr = m_ptr;
	m_ptr = optr;
	derefIfNotNull(ptr);
	return *this;
}

template<typename T> ALWAYS_INLINE RefPtr<T>& RefPtr<T>::operator=(T& object)
{
	object.ref();
	T* ptr = m_ptr;
	m_ptr = &object;
	derefIfNotNull(ptr);
	return *this;
}

template<typename T> ALWAYS_INLINE RefPtr<T>& RefPtr<T>::operator=(T* optr)
{
	refIfNotNull(optr);
	T* ptr = m_ptr;
	m_ptr = optr;
	derefIfNotNull(ptr);
	return *this;
}

template<typename T> ALWAYS_INLINE RefPtr<T>& RefPtr<T>::operator=(const PassRefPtr<T>& o)
{
	T* ptr = m_ptr;
	m_ptr = o.leakRef();
	derefIfNotNull(ptr);
	return *this;
}

template<typename T> template<typename U> ALWAYS_INLINE RefPtr<T>& RefPtr<T>::operator=(const PassRefPtr<U>& o)
{
	T* ptr = m_ptr;
	m_ptr = o.leakRef();
	derefIfNotNull(ptr);
	return *this;
}

template<typename T> inline RefPtr<T>& RefPtr<T>::operator=(RefPtr<T>&& o)
{
	RefPtr<T> ptr = WTFMove(o);
	swap(ptr);
	return *this;
}

template<typename T> template<typename U> inline RefPtr<T>& RefPtr<T>::operator=(RefPtr<U>&& o)
{
	RefPtr<T> ptr = WTFMove(o);
	swap(ptr);
	return *this;
}

template<typename T> template<typename U> inline RefPtr<T>& RefPtr<T>::operator=(Ref<U>&& reference)
{
	RefPtr ptr = WTFMove(reference);
	swap(ptr);
	return *this;
}

template<class T> ALWAYS_INLINE void RefPtr<T>::swap(RefPtr<T>& o)
{
	std::swap(m_ptr, o.m_ptr);
}

template<class T> ALWAYS_INLINE void swap(RefPtr<T>& a, RefPtr<T>& b)
{
	a.swap(b);
}

template<typename T, typename U> ALWAYS_INLINE bool operator==(const RefPtr<T>& a, const RefPtr<U>& b)
{
	return a.get() == b.get();
}

template<typename T, typename U> ALWAYS_INLINE bool operator==(const RefPtr<T>& a, U* b)
{
	return a.get() == b;
}

template<typename T> ALWAYS_INLINE bool operator==(const RefPtr<T>& a, std::nullptr_t)
{
	return a.get() == 0;
}

template<typename T, typename U> ALWAYS_INLINE bool operator==(T* a, const RefPtr<U>& b)
{
	return a == b.get();
}

template<typename T, typename U> ALWAYS_INLINE bool operator!=(const RefPtr<T>& a, const RefPtr<U>& b)
{
	return a.get() != b.get();
}

template<typename T, typename U> ALWAYS_INLINE bool operator!=(const RefPtr<T>& a, U* b)
{
	return a.get() != b;
}

template<typename T> ALWAYS_INLINE bool operator!=(const RefPtr<T>& a, std::nullptr_t)
{
	return a.get() != 0;
}

template<typename T, typename U> ALWAYS_INLINE bool operator!=(T* a, const RefPtr<U>& b)
{
	return a != b.get();
}

template<typename T, typename U> ALWAYS_INLINE RefPtr<T> static_pointer_cast(const RefPtr<U>& p)
{
	return RefPtr<T>(static_cast<T*>(p.get()));
}

template<typename T, typename U> ALWAYS_INLINE RefPtr<T> const_pointer_cast(const RefPtr<U>& p)
{
	return RefPtr<T>(const_cast<T*>(p.get()));
}

template <typename T> struct IsSmartPtr<RefPtr<T>> {
	static const bool value = true;
};

} // namespace WTF

using WTF::RefPtr;
using WTF::static_pointer_cast;
using WTF::const_pointer_cast;
